import { MutableRefObject, ForwardedRef, RefObject } from 'react';
export interface ViewportListRef {
    scrollToIndex: (index?: number, alignToTop?: boolean | ScrollIntoViewOptions, offset?: number) => void;
}
export interface ViewportListProps<T> {
    viewportRef?: MutableRefObject<HTMLElement | null> | RefObject<HTMLElement | null>;
    items?: T[];
    itemMinSize: number;
    margin?: number;
    overscan?: number;
    axis?: 'y' | 'x';
    initialIndex?: number;
    initialAlignToTop?: boolean | ScrollIntoViewOptions;
    initialOffset?: number;
    fixed?: boolean;
    children: (item: T, index: number, array: T[]) => any;
}
declare const ViewportListInner: <T extends unknown>({ viewportRef, items, itemMinSize, margin, overscan, axis, initialIndex, initialAlignToTop, initialOffset, fixed, children }: ViewportListProps<T>, ref: ForwardedRef<ViewportListRef>) => JSX.Element;
export declare const ViewportList: <T>(props: ViewportListProps<T> & {
    ref?: ForwardedRef<ViewportListRef> | undefined;
}) => ReturnType<typeof ViewportListInner>;
export default ViewportList;
